--- old/usr/src/uts/common/fs/zfs/sys/dbuf.h	2014-10-28 11:57:19.453579194 -0700
+++ new/usr/src/uts/common/fs/zfs/sys/dbuf.h	2014-10-28 11:57:19.456839661 -0700
@@ -143,6 +143,8 @@
 			boolean_t dr_nopwrite;
 		} dl;
 	} dt;
+
+	boolean_t dr_zero_write;
 } dbuf_dirty_record_t;
 
 typedef struct dmu_buf_impl {
@@ -275,9 +277,11 @@
 int dbuf_read(dmu_buf_impl_t *db, zio_t *zio, uint32_t flags);
 void dmu_buf_will_not_fill(dmu_buf_t *db, dmu_tx_t *tx);
 void dmu_buf_will_fill(dmu_buf_t *db, dmu_tx_t *tx);
+void dmu_buf_will_zero_fill(dmu_buf_t *db, dmu_tx_t *tx);
 void dmu_buf_fill_done(dmu_buf_t *db, dmu_tx_t *tx);
 void dbuf_assign_arcbuf(dmu_buf_impl_t *db, arc_buf_t *buf, dmu_tx_t *tx);
-dbuf_dirty_record_t *dbuf_dirty(dmu_buf_impl_t *db, dmu_tx_t *tx);
+dbuf_dirty_record_t *dbuf_dirty(dmu_buf_impl_t *db, dmu_tx_t *tx, boolean_t zero_write);
+dbuf_dirty_record_t *dbuf_zero_dirty(dmu_buf_impl_t *db, dmu_tx_t *tx);
 arc_buf_t *dbuf_loan_arcbuf(dmu_buf_impl_t *db);
 void dmu_buf_write_embedded(dmu_buf_t *dbuf, void *data,
     bp_embedded_type_t etype, enum zio_compress comp,
